## h5z-zfp 1.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

# Fail immediately if not using an out-of-source build
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  message(FATAL_ERROR
    "In-source builds are not supported.  Please create a build directory "
    "separate from the source directory")
endif ()

if (POLICY CMP0074)
  # find_package() uses <PackageName>_ROOT variables.
  cmake_policy (SET CMP0074 NEW)
endif ()

if (POLICY CMP0083)
  # To control generation of Position Independent Executable (PIE) or not,
  # some flags are required at link time.
  cmake_policy (SET CMP0083 NEW)
endif ()

# Avoid warning about DOWNLOAD_EXTRACT_TIMESTAMP in CMake 3.24:
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
    cmake_policy(SET CMP0135 NEW)
endif()

get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

#------------------------------------------------------------------------------#
# Parse version number from H5Zzfp_version.h
#------------------------------------------------------------------------------#
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_MAJOR")
string(REGEX REPLACE "^.*MAJOR " "" H5Z_ZFP_VERSION_MAJOR "${H5Z_ZFP_H}")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_MINOR")
string(REGEX REPLACE "^.*MINOR " "" H5Z_ZFP_VERSION_MINOR "${H5Z_ZFP_H}")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/H5Zzfp_version.h" H5Z_ZFP_H REGEX "^\#define H5Z_FILTER_ZFP_VERSION_PATCH")
string(REGEX REPLACE "^.*PATCH " "" H5Z_ZFP_VERSION_PATCH "${H5Z_ZFP_H}")
set(H5Z_ZFP_VERSION "${H5Z_ZFP_VERSION_MAJOR}.${H5Z_ZFP_VERSION_MINOR}.${H5Z_ZFP_VERSION_PATCH}")

project(H5Z_ZFP VERSION ${H5Z_ZFP_VERSION} LANGUAGES C)

# setup common output folders
include (cmake/HDFMacros.cmake)
SET_HDF_BUILD_TYPE()
DEFAULT_FOLDERS()

#------------------------------------------------------------------------------#
# Compile options.
#------------------------------------------------------------------------------#
option(FORTRAN_INTERFACE "Enable the Fortran interface" ON)
if (FORTRAN_INTERFACE)
  enable_language(Fortran)
endif ()
#------------------------------------------------------------------------------#
# Some boilerplate to setup nice output directories
#------------------------------------------------------------------------------#
set(CMAKE_INSTALL_BINDIR bin)
set(CMAKE_INSTALL_LIBDIR lib)
set(CMAKE_INSTALL_INCLUDEDIR include)
set(CMAKE_INSTALL_CMAKEDIR lib/cmake/h5z_zfp)

#------------------------------------------------------------------------------#
# Required packages
#------------------------------------------------------------------------------#
# Find HDF5, relies on HDF5_DIR or HDF5_ROOT being set in environment.
HDF5_SUPPORT ()
if (NOT HDF5_FOUND)
  message (FATAL_ERROR "HDF5 is Required for h5z_zfp")
endif ()

# Find MPI depending on if HDF5 needs MPI.
if ((HDF5_IS_PARALLEL OR HDF5_ENABLE_PARALLEL) AND ("${HDF5_VERSION}" VERSION_EQUAL "1.14.0"))
  find_package(MPI REQUIRED COMPONENTS C)
endif()

# Find ZFP, relies on ZFP_DIR or ZFP_ROOT being set in environment.
find_package(ZFP REQUIRED CONFIG)
if (NOT ZFP_FOUND)
  message (FATAL_ERROR "ZFP is Required for h5z_zfp")
endif ()

#------------------------------------------------------------------------------#
# Add source
#------------------------------------------------------------------------------#
add_subdirectory(${CMAKE_SOURCE_DIR}/src)

#-----------------------------------------------------------------------------
# Dashboard and Testing Settings
#-----------------------------------------------------------------------------
option (BUILD_TESTING "Build h5z-zfp Unit Testing" OFF)
if (BUILD_TESTING)
  set (DART_TESTING_TIMEOUT 1200 CACHE STRING
       "Timeout in seconds for each test (default 1200=20minutes)")
  enable_testing ()
  include (CTest)

  add_subdirectory(${CMAKE_SOURCE_DIR}/test)
endif ()

#------------------------------------------------------------------------------#
# Packaging
#------------------------------------------------------------------------------#
# Install h5z_zfp-config.cmake and h5z_zfp-config-version.cmake
set(H5Z_ZFP_CONFIG_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/h5z_zfp-config.cmake.in)
set(H5Z_ZFP_CONFIG_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/h5z_zfp-config.cmake)
configure_file(${H5Z_ZFP_CONFIG_IN} ${H5Z_ZFP_CONFIG_OUT} @ONLY)
set(H5Z_ZFP_CONFIG_VERSION_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/h5z_zfp-config-version.cmake.in)
set(H5Z_ZFP_CONFIG_VERSION_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/h5z_zfp-config-version.cmake)
configure_file(${H5Z_ZFP_CONFIG_VERSION_IN} ${H5Z_ZFP_CONFIG_VERSION_OUT} @ONLY)
install(FILES ${H5Z_ZFP_CONFIG_OUT}
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})
install(FILES ${H5Z_ZFP_CONFIG_VERSION_OUT}
        DESTINATION ${CMAKE_INSTALL_CMAKEDIR})

=== Makefile ===
# Include config.make only if we're not looking for help
ifeq ($(findstring help, $(strip $(MAKECMDGOALS))),)
    ifeq ($(findstring tools, $(strip $(MAKECMDGOALS))),)
        ifeq ($(findstring clean, $(strip $(MAKECMDGOALS))),)
            ifeq ($(findstring dist, $(strip $(MAKECMDGOALS))),)
                include config.make
            endif
        endif
    endif
endif

# Get version string from H5Z-ZFP
H5Z_ZFP_VERSINFO := $(shell grep '^\#define H5Z_FILTER_ZFP_VERSION_[MP]' src/H5Zzfp_version.h | cut -d' ' -f3 | tr '\n' '.' | cut -d'.' -f-3 2>/dev/null)

.PHONY: help all clean dist install

help:
	@echo ""
	@echo ""
	@echo ""
	@echo "                 This is H5Z-ZFP version $(H5Z_ZFP_VERSINFO)."
	@echo "See http://h5z-zfp.readthedocs.io/en/latest/ file for more info."
	@echo ""
	@echo "Typical make command is..."
	@echo ""
	@echo "    make CC=<C-compiler> HDF5_HOME=<path> ZFP_HOME=<path> PREFIX=<path> all"
	@echo ""
	@echo "where <path> is a dir whose children are include/lib/bin subdirs."
	@echo "HDF5_HOME can also be set using an INC,LIB,BIN triplet specifying"
	@echo "HDF5 include, library and binary dirs separated by commas."
	@echo "Standard make variables (e.g. CFLAGS, LD, etc.) can be set as usual."
	@echo "Optionally, add FC=<fortran-compiler> to include Fortran support and tests."
	@echo ""
	@echo "Available make targets are..."
	@echo "    all     - build everything needed for H5Z-ZFP plugin/lib"
	@echo "    check   - all + run tests"
	@echo "    tools   - build tools (currently just print_h5repack_farg)"
	@echo "    install - install plugin/lib"
	@echo "    clean   - clean away all derived targets"
	@echo "    dist    - create distribution tarfile"
	@echo "    help    - this help message"

all:
	cd src; $(MAKE) $(MAKEVARS) $@

check: all
	cd test; $(MAKE) $(MAKEVARS) $@

tools:
	cd test; $(MAKE) $(MAKEVARS) print_h5repack_farg

install: all
	cd src; $(MAKE) $(MAKEVARS) $@

clean:
	rm -f H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz
	cd src; $(MAKE) $(MAKEVARS) $@
	cd test; $(MAKE) $(MAKEVARS) $@

dist:	clean
	rm -rf H5Z-ZFP-$(H5Z_ZFP_VERSINFO) H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz; \
	mkdir H5Z-ZFP-$(H5Z_ZFP_VERSINFO); \
	tar cf - --exclude ".git*" --exclude H5Z-ZFP-$(H5Z_ZFP_VERSINFO) . | tar xf - -C H5Z-ZFP-$(H5Z_ZFP_VERSINFO); \
	tar cvf - H5Z-ZFP-$(H5Z_ZFP_VERSINFO) | gzip --best > H5Z-ZFP-$(H5Z_ZFP_VERSINFO).tar.gz; \
	rm -rf H5Z-ZFP-$(H5Z_ZFP_VERSINFO);

=== src/CMakeLists.txt ===
# Define headers.
set(h5z_zfp_headers
  H5Zzfp.h H5Zzfp_lib.h H5Zzfp_plugin.h H5Zzfp_props.h H5Zzfp_version.h)

#------------------------------------------------------------------------------#
# Static library
#------------------------------------------------------------------------------#
# Define source
set(h5z_zfp_lib_source
  ${h5z_zfp_headers}
  H5Zzfp_props_private.h
  H5Zzfp.c H5Zzfp_props.c)

if (FORTRAN_INTERFACE)
  list(APPEND h5z_zfp_lib_source H5Zzfp_props_f.F90)
endif ()

add_library(h5z_zfp_static STATIC ${h5z_zfp_lib_source})
target_compile_definitions(h5z_zfp_static PRIVATE H5Z_ZFP_AS_LIB)
target_include_directories(h5z_zfp_static
  PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    ${HDF5_INCLUDE_DIRS}
    "$<$<BOOL:${FORTRAN_INTERFACE}>:${HDF5_FORTRAN_INCLUDE_DIRS}>"
)
target_link_libraries(h5z_zfp_static PUBLIC zfp::zfp ${HDF5_LIBRARIES} $<$<BOOL:${FORTRAN_INTERFACE}>:${HDF5_FORTRAN_LIBRARIES}>)
set_target_properties(h5z_zfp_static PROPERTIES POSITION_INDEPENDENT_CODE 1)
set_target_properties(h5z_zfp_static PROPERTIES
  OUTPUT_NAME h5zzfp
  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin
  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib)
install(TARGETS h5z_zfp_static
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

#------------------------------------------------------------------------------#
# Shared library
#------------------------------------------------------------------------------#
# Define source
set(h5z_zfp_plugin_source
  ${h5z_zfp_headers}
  H5Zzfp.c)

add_library(h5z_zfp_shared SHARED ${h5z_zfp_plugin_source})
target_include_directories(h5z_zfp_shared
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    ${HDF5_INCLUDE_DIRS})
target_link_libraries(h5z_zfp_shared PUBLIC zfp::zfp ${HDF5_LIBRARIES})
set_target_properties(h5z_zfp_shared PROPERTIES
  OUTPUT_NAME h5zzfp
  RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plugin
  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plugin
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/plugin)
install(TARGETS h5z_zfp_shared
  RUNTIME DESTINATION plugin
  ARCHIVE DESTINATION plugin
  LIBRARY DESTINATION plugin)

#------------------------------------------------------------------------------#
# Install header and module files.
#------------------------------------------------------------------------------#
install(FILES ${h5z_zfp_headers}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if (FORTRAN_INTERFACE)
  install(FILES ${CMAKE_BINARY_DIR}/bin/h5zzfp_props_f.mod
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
endif ()

=== src/Makefile ===
ifneq ($(strip $(MAKECMDGOALS)),clean)
    include ../config.make
endif

.PHONY: all lib clean

# The filter compiled to be used as a plugin
H5Zzfp_plugin.o: H5Zzfp.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The filter compiled to be used as a library
H5Zzfp_lib.o: H5Zzfp.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_AS_LIB $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The plugin shared lib (HDF5 expects it to be named "lib*.{so,dylib}"
plugin/libh5zzfp.$(SOEXT): H5Zzfp_plugin.o
	rm -rf plugin
	mkdir plugin
	$(CC) $< $(SHFLAG) -o plugin/libh5zzfp.$(SOEXT) \
	    $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) \
	    -L$(ZFP_LIB) -L$(HDF5_LIB) -lhdf5 -lzfp $(LDFLAGS)

# Alias target for filter plugin
plugin: plugin/libh5zzfp.$(SOEXT)

# C language properties interface
H5Zzfp_props.o: H5Zzfp_props.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# Fortran language properties interface
H5Zzfp_props_f.o H5Zzfp_props_f.mod: H5Zzfp_props_f.F90
	$(FC) -c $< -o $@ $(FCFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

# The filter member of the filter library
libh5zzfp.a(H5Zzfp_lib.o): H5Zzfp_lib.o
	$(AR) cr libh5zzfp.a $<

# The C properties interface member of the filter library
libh5zzfp.a(H5Zzfp_props.o): H5Zzfp_props.o
	$(AR) cr libh5zzfp.a $<

# The Fortran properties interface member of the filter library
libh5zzfp.a(H5Zzfp_props_f.o): H5Zzfp_props_f.o
	$(AR) cr libh5zzfp.a $<

# Alias target for filter library, conditionally includes Fortran
LIBOBJ = libh5zzfp.a(H5Zzfp_lib.o) libh5zzfp.a(H5Zzfp_props.o)
ifneq ($(FC),)
LIBOBJ += libh5zzfp.a(H5Zzfp_props_f.o)
endif
lib: $(LIBOBJ)

all: lib plugin

install: all
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/{plugin,include,lib}
	$(INSTALL) plugin/libh5zzfp.$(SOEXT) $(DESTDIR)$(PREFIX)/plugin
	$(INSTALL) libh5zzfp.a $(DESTDIR)$(PREFIX)/lib
	$(INSTALL) -m 644 H5Zzfp.h H5Zzfp_lib.h H5Zzfp_plugin.h H5Zzfp_version.h H5Zzfp_props.h $(DESTDIR)$(PREFIX)/include
ifneq ($(FC),)
	$(INSTALL) -m 644 *.[mM][oO][dD] $(DESTDIR)$(PREFIX)/include
endif

clean:
	rm -rf plugin
	rm -f libh5zzfp.a *.o *.[mM][oO][dD]
	rm -f *.gcno *.gcda *.gcov
	rm -f H5Zzfp_props_f.mod

=== test/CMakeLists.txt ===
set(ZFP_LIB_VERSION ${ZFP_VERSION_MAJOR}${ZFP_VERSION_MINOR}${ZFP_VERSION_PATCH})
if (ZFP_VERSION VERSION_GREATER_EQUAL 1.0.0)
  set(ZFP_LIB_VERSION ${ZFP_LIB_VERSION}${ZFP_VERSION_TWEAK})
endif ()
set(ZFP_HAS_CFP 0)
if (ZFP_CFP_ENABLED)
  set(ZFP_HAS_CFP 1)
endif()

# HDF5 docs say H5Dwrite_chunk was introduced in 1.10.2
set(HDF5_HAS_WRITE_CHUNK 0)
if ("${HDF5_VERSION}" VERSION_GREATER_EQUAL "1.10.2")
    set(HDF5_HAS_WRITE_CHUNK 1)
endif()

#------------------------------------------------------------------------------#
# Setup HDF5_PLUGIN_PATH
#------------------------------------------------------------------------------#
get_target_property(HDF5_PLUGIN_PATH h5z_zfp_shared RUNTIME_OUTPUT_DIRECTORY)
if (_isMultiConfig)
  set(HDF5_PLUGIN_PATH "${HDF5_PLUGIN_PATH}/${HDF_CFG_NAME}")
endif ()

#------------------------------------------------------------------------------#
# Plugin and library write & read tests (No check implemented)
#------------------------------------------------------------------------------#
add_executable(test_write_plugin test_write.c)
target_compile_definitions(test_write_plugin PRIVATE H5Z_ZFP_USE_PLUGIN)
target_compile_definitions(test_write_plugin PRIVATE ZFP_LIB_VERSION=0x${ZFP_LIB_VERSION})
target_link_libraries(test_write_plugin h5z_zfp_shared)

add_executable(test_read_plugin test_read.c)
target_compile_definitions(test_read_plugin PRIVATE H5Z_ZFP_USE_PLUGIN)
target_link_libraries(test_read_plugin h5z_zfp_shared)

add_executable(test_write_lib test_write.c)
target_compile_definitions(test_write_lib PRIVATE ZFP_LIB_VERSION=0x${ZFP_LIB_VERSION})
target_compile_definitions(test_write_lib PRIVATE HDF5_HAS_WRITE_CHUNK=${HDF5_HAS_WRITE_CHUNK})
target_compile_definitions(test_write_lib PRIVATE ZFP_HAS_CFP=${ZFP_HAS_CFP})
target_link_libraries(test_write_lib h5z_zfp_static)
if (ZFP_CFP_ENABLED)
  target_link_libraries(test_write_lib zfp::cfp)
endif ()

add_executable(test_read_lib test_read.c)
target_link_libraries(test_read_lib h5z_zfp_static)

if (FORTRAN_INTERFACE)
  add_executable(test_rw_fortran test_rw_fortran.F90)
  target_link_libraries(test_rw_fortran h5z_zfp_static)
  set_target_properties (test_rw_fortran PROPERTIES LINKER_LANGUAGE Fortran)
endif ()

#------------------------------------------------------------------------------#
# Tests
#------------------------------------------------------------------------------#

if (MSVC)
  string(REPLACE ";" "\\;" ESCAPED_PATH "$ENV{PATH}")
endif ()

# Rate
set(RATE_RATE 32 16 8 4)
if (MSVC)
  set(RATE_DIFF 3e-7 0.008 2.0 45)
else ()
  set(RATE_DIFF 1e-7 0.003 0.4 33)
endif ()
list(LENGTH RATE_RATE NRATES)
math(EXPR NRATES "${NRATES} - 1")
foreach (IRATE RANGE ${NRATES})
  list(GET RATE_RATE ${IRATE} RATE)
  list(GET RATE_DIFF ${IRATE} DIFF)

  add_test(
    NAME
      test-rate-write-${RATE}
    COMMAND
      $<TARGET_FILE:test_write_plugin> zfpmode=1 rate=${RATE} ofile=test_zfp-rate-${RATE}.h5
  )
  set_property(
    TEST
      test-rate-write-${RATE}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-rate-write-${RATE}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()

  add_test(
    NAME
      test-rate-read-${RATE}
    COMMAND
      $<TARGET_FILE:test_read_plugin> max_absdiff=${DIFF} max_reldiff=${DIFF} ifile=test_zfp-rate-${RATE}.h5
  )
  set_property(
    TEST
      test-rate-read-${RATE}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-rate-read-${RATE}
      APPEND
      PROPERTY
        ENVIRONMENT "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()
  set_tests_properties (test-rate-read-${RATE} PROPERTIES DEPENDS test-rate-write-${RATE})

  add_test(
    NAME
      test-rate-cleanup-${RATE}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-rate-${RATE}.h5
  )
  set_tests_properties (test-rate-cleanup-${RATE} PROPERTIES DEPENDS test-rate-read-${RATE})

  set_tests_properties(test-rate-write-${RATE}   PROPERTIES FIXTURES_SETUP    "rate-read-${RATE};rate-cleanup-${RATE}")
  set_tests_properties(test-rate-write-${RATE}   PROPERTIES FIXTURES_REQUIRED "rate-write-${RATE}")
  set_tests_properties(test-rate-read-${RATE}    PROPERTIES FIXTURES_REQUIRED "rate-read-${RATE}")
  set_tests_properties(test-rate-cleanup-${RATE} PROPERTIES FIXTURES_REQUIRED "rate-cleanup-${RATE}")
  set_tests_properties(test-rate-cleanup-${RATE} PROPERTIES FIXTURES_CLEANUP  "rate-write-${RATE};rate-read-${RATE}")

  add_test(
    NAME
      test-lib-rate-write-${RATE}
    COMMAND
      $<TARGET_FILE:test_write_lib> zfpmode=1 rate=${RATE} ofile=test_zfp-lib-rate-${RATE}.h5
  )

  add_test(
    NAME
      test-lib-rate-read-${RATE}
    COMMAND
      $<TARGET_FILE:test_read_lib> max_absdiff=${DIFF} max_reldiff=${DIFF} ifile=test_zfp-lib-rate-${RATE}.h5
  )
  set_tests_properties (test-lib-rate-read-${RATE} PROPERTIES DEPENDS test-lib-rate-write-${RATE})

  add_test(
    NAME
      test-lib-rate-cleanup-${RATE}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-lib-rate-${RATE}.h5
  )
  set_tests_properties (test-lib-rate-cleanup-${RATE} PROPERTIES DEPENDS test-lib-rate-read-${RATE})

  set_tests_properties(test-lib-rate-write-${RATE}   PROPERTIES FIXTURES_SETUP    "lib-rate-read-${RATE};lib-rate-cleanup-${RATE}")
  set_tests_properties(test-lib-rate-write-${RATE}   PROPERTIES FIXTURES_REQUIRED "lib-rate-write-${RATE}")
  set_tests_properties(test-lib-rate-read-${RATE}    PROPERTIES FIXTURES_REQUIRED "lib-rate-read-${RATE}")
  set_tests_properties(test-lib-rate-cleanup-${RATE} PROPERTIES FIXTURES_REQUIRED "lib-rate-cleanup-${RATE}")
  set_tests_properties(test-lib-rate-cleanup-${RATE} PROPERTIES FIXTURES_CLEANUP  "lib-rate-write-${RATE};lib-rate-read-${RATE}")

  if (NOT MSVC AND FORTRAN_INTERFACE)
    add_test(
      NAME
        test-rate-write-${RATE}-f
      COMMAND
        $<TARGET_FILE:test_rw_fortran> zfpmode 1 rate ${RATE} ofile test_zfp_fortran-rate-${RATE}.h5
    )

    add_test(
      NAME
        test-rate-info1-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}"
        -D "TEST_PROGRAM=${HDF5_DUMP_EXECUTABLE}"
        -D "TEST_FILE=test_zfp_fortran-rate-${RATE}.h5"
        -D "TEST_DSET=compressed"
        -D "TEST_RATE=${RATE}"
        -D "RATE_START=64"
        -P "${CMAKE_CURRENT_SOURCE_DIR}/h5dump-rate.cmake"
    )
    set_tests_properties (test-rate-info1-${RATE}-f PROPERTIES DEPENDS test-rate-write-${RATE}-f)

    add_test(
      NAME
        test-rate-info2-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}"
        -D "TEST_PROGRAM=${HDF5_DUMP_EXECUTABLE}"
        -D "TEST_FILE=test_zfp_fortran-rate-${RATE}.h5"
        -D "TEST_DSET=compressed-plugin"
        -D "TEST_RATE=${RATE}"
        -D "RATE_START=64"
        -P "${CMAKE_CURRENT_SOURCE_DIR}/h5dump-rate.cmake"
    )
    set_tests_properties (test-rate-info2-${RATE}-f PROPERTIES DEPENDS test-rate-info1-${RATE}-f)

    add_test(
      NAME
        test-rate-cleanup-${RATE}-f
      COMMAND
        "${CMAKE_COMMAND}" -E remove test_zfp_fortran-rate-${RATE}.h5
    )
    set_tests_properties (test-rate-cleanup-${RATE}-f PROPERTIES DEPENDS test-rate-info2-${RATE}-f)

    set_tests_properties(test-rate-write-${RATE}-f   PROPERTIES FIXTURES_SETUP    "rate-info1-${RATE}-f;rate-info1-${RATE}-f;rate-cleanup-${RATE}-f")
    set_tests_properties(test-rate-write-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-write-${RATE}-f")
    set_tests_properties(test-rate-info1-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-info1-${RATE}-f")
    set_tests_properties(test-rate-info2-${RATE}-f   PROPERTIES FIXTURES_REQUIRED "rate-info2-${RATE}-f")
    set_tests_properties(test-rate-cleanup-${RATE}-f PROPERTIES FIXTURES_REQUIRED "rate-cleanup-${RATE}-f")
    set_tests_properties(test-rate-cleanup-${RATE}-f PROPERTIES FIXTURES_CLEANUP  "rate-write-${RATE}-f;rate-info1-${RATE}-f;rate-info1-${RATE}-f")
  endif ()
endforeach ()

# Accuracy
set(ACC_NO 1 2 3 4)
set(ACC_ACC 0.1 0.01 0.001 0.0001)
set(ACC_DIFF 0.025 0.004 0.0006 4e-5)
list(LENGTH ACC_NO NACCS)
math(EXPR NACCS "${NACCS} - 1")
foreach (IACC RANGE ${NACCS})
  list(GET ACC_NO ${IACC} NUMBER)
  list(GET ACC_ACC ${IACC} ACC)
  list(GET ACC_DIFF ${IACC} DIFF)

  add_test(
    NAME
      test-accuracy-write-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_write_plugin> zfpmode=3 acc=${ACC} ofile=test_zfp-acc-${NUMBER}.h5
  )
  set_property(
    TEST
      test-accuracy-write-${NUMBER}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-accuracy-write-${NUMBER}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()

  add_test(
    NAME
      test-accuracy-read-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_read_plugin> ret=1 max_absdiff=${DIFF} ifile=test_zfp-acc-${NUMBER}.h5
  )
  set_property(
    TEST
      test-accuracy-read-${NUMBER}
    APPEND
    PROPERTY
      ENVIRONMENT "HDF5_PLUGIN_PATH=${HDF5_PLUGIN_PATH}"
  )
  if (MSVC)
    set_property(
      TEST
        test-accuracy-read-${NUMBER}
      APPEND
      PROPERTY
        ENVIRONMENT
          "PATH=${ESCAPED_PATH}\\;${HDF5_PLUGIN_PATH}"
    )
  endif ()
  set_tests_properties (test-accuracy-read-${NUMBER} PROPERTIES DEPENDS test-accuracy-write-${NUMBER})

  add_test(
    NAME
      test-accuracy-cleanup-${NUMBER}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-acc-${NUMBER}.h5
  )
  set_tests_properties (test-accuracy-cleanup-${NUMBER} PROPERTIES DEPENDS test-accuracy-read-${NUMBER})

  set_tests_properties(test-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_SETUP    "accuracy-read-${NUMBER};accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_REQUIRED "accuracy-write-${NUMBER}")
  set_tests_properties(test-accuracy-read-${NUMBER}    PROPERTIES FIXTURES_REQUIRED "accuracy-read-${NUMBER}")
  set_tests_properties(test-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_REQUIRED "accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_CLEANUP  "accuracy-write-${NUMBER};accuracy-read-${NUMBER}")

  add_test(
    NAME
      test-lib-accuracy-write-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_write_lib> zfpmode=3 acc=${ACC} ofile=test_zfp-lib-acc-${NUMBER}.h5
  )

  add_test(
    NAME
      test-lib-accuracy-read-${NUMBER}
    COMMAND
      $<TARGET_FILE:test_read_lib> ret=1 max_absdiff=${DIFF} ifile=test_zfp-lib-acc-${NUMBER}.h5
  )
  set_tests_properties (test-lib-accuracy-read-${NUMBER} PROPERTIES DEPENDS test-lib-accuracy-write-${NUMBER})

  add_test(
    NAME
      test-lib-accuracy-cleanup-${NUMBER}
    COMMAND
      "${CMAKE_COMMAND}" -E remove test_zfp-lib-acc-${NUMBER}.h5
  )
  set_tests_properties (test-lib-accuracy-cleanup-${NUMBER} PROPERTIES DEPENDS test-lib-accuracy-read-${NUMBER})

  set_tests_properties(test-lib-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_SETUP    "lib-accuracy-read-${NUMBER};lib-accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-lib-accuracy-write-${NUMBER}   PROPERTIES FIXTURES_REQUIRED "lib-accuracy-write-${NUMBER}")
  set_tests_properties(test-lib-accuracy-read-${NUMBER}    PROPERTIES FIXTURES_REQUIRED "lib-accuracy-read-${NUMBER}")
  set_tests_properties(test-lib-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_REQUIRED "lib-accuracy-cleanup-${NUMBER}")
  set_tests_properties(test-lib-accuracy-cleanup-${NUMBER} PROPERTIES FIXTURES_CLEANUP  "lib-accuracy-write-${NUMBER};lib-accuracy-read-${NUMBER}")

  if (FORTRAN_INTERFACE)
    add_test(
      NAME
        test-accuracy-write-${NUMBER}-f
      COMMAND
        $<TARGET_FILE:test_rw_fortran> zfpmode 3 acc ${ACC} ofile test_zfp_fortran-acc-${NUMBER}.h5 write
    )

    add_test(
      NAME
        test-accuracy-diff1-${NUMBER}-f
      COMMAND

=== test/Makefile ===
# Include config.make only if we're not making this tool
ifneq ($(strip $(MAKECMDGOALS)),print_h5repack_farg)
    ifneq ($(strip $(MAKECMDGOALS)),clean)
        include ../config.make
    endif
endif

# printf symbols for output of test results
NO_COLOR=\033[0m
OK_COLOR=\033[32;01m
ERROR_COLOR=\033[31;01m
SKIP_COLOR=\033[0;34m
padlimit=60
padlength=60

ZFP_LIBS = -lzfp
ifeq ($(ZFP_HAS_CFP),1)
    ZFP_LIBS += -lcfp -lstdc++
endif

.PHONY: lib plugin check patch clean

patch:
	@echo "If using HDF5-1.8, make sure you have patched repack"

plugin:
	cd ../src; $(MAKE) $(MAKEVARS) $@

lib:
	cd ../src; $(MAKE) $(MAKEVARS) $@

test_write_plugin.o: test_write.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_lib.o: test_write.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_HAS_CFP=$(ZFP_HAS_CFP) -DHDF5_HAS_WRITE_CHUNK=$(HDF5_HAS_WRITE_CHUNK) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_write_plugin: test_write_plugin.o plugin
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_write_lib: test_write_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_read_plugin.o: test_read.c
	$(CC) -c $< -o $@ -DH5Z_ZFP_USE_PLUGIN $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_lib.o: test_read.c
	$(CC) -c $< -o $@ $(CFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_read_plugin: test_read_plugin.o plugin
	$(CC) $< -o $@ $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L$(HDF5_LIB) -L$(ZFP_LIB) -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_read_lib: test_read_lib.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

test_error.o: test_error.c
	$(CC) -c $< -o $@ $(CFLAGS) -DZFP_LIB_VERSION=0x$(ZFP_LIB_VERSION) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)

test_error: test_error.o lib
	$(CC) $< -o $@ $(CFLAGS) $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5 $(ZFP_LIBS) -lm $(LDFLAGS)

print_h5repack_farg: print_h5repack_farg.o
	$(CC) $< -o $@ $(LDFLAGS)

print_h5repack_farg.o: print_h5repack_farg.c
	$(CC) -c $< -o $@ $(CFLAGS) -I../src

ifneq ($(FC),) # Fortran Tests [

test_rw_fortran: test_rw_fortran.o lib
	$(FC) $(FCFLAGS) -o $@ $< $(PREPATH)$(HDF5_LIB) $(PREPATH)$(ZFP_LIB) -L../src -L$(HDF5_LIB) -L$(ZFP_LIB) -lh5zzfp -lhdf5_fortran -lhdf5 $(ZFP_LIBS) $(LDFLAGS)

%.o:%.F90
	$(FC)  -o $@ -c $< $(FCFLAGS) -I$(H5Z_ZFP_BASE) -I$(ZFP_INC) -I$(HDF5_INC)


# Note: The write-half of all the Fortran tests utilize the default and properties
# interface library to control the filter. The read-half uses the plugin.

test-default : test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
         x="./test_rw_fortran"; \
	 printf "$$x"; \
	 printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
         $$x 2>&1 1>/dev/null; \
         if [[ $$status -ne 0 ]]; then \
	     printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	     touch check-failed; \
	     exit 0; \
          fi; \
	  printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \

# Decrease bit rate and confirm compression ratio increases
test-rate-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for r in 32 16 8 4; do\
            x="./test_rw_fortran zfpmode 1 rate $$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed-plugin -p test_zfp_fortran.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DUMP*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for a in 0.1 0.01 0.001 0.0001; do\
            x="./test_rw_fortran zfpmode 3 acc $$a write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \

# Increase precision and confirm diff count for given tolerance drops
test-precision-f: plugin test_rw_fortran
	 @echo " "; \
	 pad=$$(printf '%*s' "$(padlimit)"); \
	 pad=$${pad// /.}; \
	 for p in 12 16 20 24; do\
            x="./test_rw_fortran zfpmode 2 prec $$p write"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    $$x >/dev/null 2>/dev/null; \
            status=$$?; \
            if [[ $$status -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        touch check-failed; \
	        exit 0; \
            fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	    if [[ $$ldiffcnt -ne 0 ]] && [[ $$diffcnt -gt $$ldiffcnt ]]; then \
	        printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	        touch check-failed; \
		exit 0; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	 done; \

# Ensure reversible gives bit-for-bit identical results
test-reversible-f: plugin test_rw_fortran
	@echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	x="./test_rw_fortran zfpmode 5 write"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	$$x >/dev/null 2>/dev/null; \
        status=$$?; \
        if [[ $$status -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    touch check-failed; \
            exit 0; \
         fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	diffcnt=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -p 0.00001 test_zfp_fortran.h5 test_zfp_fortran.h5 compressed-plugin original | grep 'differences found' | cut -d' ' -f1); \
	if [[ $$diffcnt -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED *H5DIFF*$(NO_COLOR)]\n"; \
	    touch check-failed; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n\n"; \

endif # ] ifneq ($(FC),)

# Decrease bit rate and confirm compression ratio increases
test-rate: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for r in 32 16 8 4; do \
	    expected_ratio=$$(expr 64 \/ $$r); \
	    x="./test_write_plugin zfpmode=1 rate=$$r"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
            fi; \
	    actual_ratio=$$(env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5dump -H -d compressed -p test_zfp.h5 | grep COMPRESSION | cut -d':' -f1 | cut -d'(' -f2 | cut -d'.' -f1); \
	    if [[ $$expected_ratio -ne $$actual_ratio ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin rate tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \
	printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"

# Increase accuracy and test absolute error tolerance is within accuracy
test-accuracy: plugin test_write_plugin
	@failed=0; \
	echo " "; \
	pad=$$(printf '%*s' "$(padlimit)"); \
	pad=$${pad// /.}; \
	for a in 0.1 0.01 0.001 0.0001; do\
	    x="./test_write_plugin zfpmode=3 acc=$$a"; \
            printf "$$x"; \
	    printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
	    env HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $$x 2>&1 1>/dev/null; \
            if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    env LD_LIBRARY_PATH=$(HDF5_LIB):$(LD_LIBRARY_PATH) HDF5_PLUGIN_PATH=$(H5Z_ZFP_PLUGIN) $(HDF5_BIN)/h5diff -v -d $$a test_zfp.h5 test_zfp.h5 compressed original 2>&1 1>/dev/null; \
	    if [[ $$? -ne 0 ]]; then \
	        printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	        echo "Plugin accuracy test failed for accuracy=$$a"; \
	        failed=1; \
	        touch check-failed; \
	        continue; \
	    fi; \
	    printf " [$(OK_COLOR)PASSED$(NO_COLOR)] \n"; \
	done; \
	x="Plugin accuracy tests"; \
        printf "$$x"; \
	printf ' %*.*s' 0 $$(($(padlength) - $${#x} )) "$$pad"; \
        if [[ $$failed -ne 0 ]]; then \
	    printf " [$(ERROR_COLOR)FAILED$(NO_COLOR)]\n"; \
	    exit 0; \
	fi; \

=== debian/changelog ===
h5z-zfp (1.1.1-2) unstable; urgency=medium

  * d/t/control: No need to rebuild, rely on the testbed
    setup to check the rebuild.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 19 Jan 2024 13:27:49 +0100

h5z-zfp (1.1.1-1) unstable; urgency=medium

  * Team upload.

  [ Helmut Grohne ]
  * New upstream version 1.1.0+git20230428

  [ Picca Frédéric-Emmanuel ]
  * d/watch: Fixed by using the github snipset from uscan documentation
  * New upstream version 1.1.1
  * d/t/control: run the upstream testsuite.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 18 Jan 2024 11:48:33 +0100

=== debian/control ===
Source: h5z-zfp
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Freexian Packaging Team <team+freexian@tracker.debian.org>,
Build-Depends:
 architecture-is-little-endian,
 debhelper-compat (= 13),
 dh-fortran-mod (>= 0.11),
 dh-sequence-sphinxdoc <!nodoc>,
 gfortran,
 hdf5-tools,
 libhdf5-dev,
 libhdf5-mpi-dev,
 libzfp-dev,
 mpi-default-dev,
 pkg-config,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/LLNL/H5Z-ZFP
Vcs-Git: https://salsa.debian.org/science-team/h5z-zfp.git
Vcs-Browser: https://salsa.debian.org/science-team/h5z-zfp

Package: hdf5-filter-plugin-zfp-serial
Provides:
 hdf5-plugin-zfp,
Conflicts:
 hdf5-plugin-zfp,
Replaces:
 hdf5-plugin-zfp,
# h5z-zfp currently fails on big-endian machines. See: https://github.com/LLNL/H5Z-ZFP/issues/95
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${sphinxdoc:Depends},
Description: Compression plugin for the HDF5 library using ZFP compression
 H5Z-ZFP is a compression filter for HDF5 using the ZFP compression library,
 supporting lossy and lossless compression of floating point and integer data
 to meet bitrate, accuracy, and/or precision targets.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk

# From https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules
# FIXME: is there a way to get these computed automatically? They are when not
# using make
INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -m  755
INSTALL_SCRIPT  = $(INSTALL) -p    -m  755
INSTALL_DIR     = $(INSTALL) -p -d -m  755

PLUGIN_DIR_SERIAL = $(shell $(PKG_CONFIG) hdf5-serial  --variable=PluginDir)
INCLUDEDIR = /usr/include
LIBDIR = /usr/lib/$(DEB_HOST_MULTIARCH)
DESTDIR ?= debian/tmp

# Bug: buildtools.mk reports an executable for gfortran that does not actually
# exist. I need to override it here, and this is to be removed once
# buildtools.mk gives working results for FC/F77
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1024421
FC=$(DEB_HOST_GNU_TYPE)-gfortran

CFLAGS += $(CPPFLAGS)
FCFLAGS += $(CPPFLAGS)

UPSTREAM_MAKE_ARGS_SERIAL = FC=$(FC) CC=$(CC) PREFIX=/usr ZFP_HOME=/usr \
			    HDF5_HOME=$(INCLUDEDIR)/hdf5/serial,$(LIBDIR)/hdf5/serial,/usr/bin

# Using make instead of cmake. Upstream has both, but their instructions cover
# make only, and building with cmake does not work out of the box. I assume
# that make is the supported build system for now
%:
	dh $@ --buildsystem=makefile --without autoreconf

override_dh_auto_clean:
	make $(UPSTREAM_MAKE_ARGS_SERIAL) clean

override_dh_auto_build:
	dh_auto_build -- $(UPSTREAM_MAKE_ARGS_SERIAL) all
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	make -C docs html
endif

override_dh_auto_test:
	cd test && make $(UPSTREAM_MAKE_ARGS_SERIAL) check

# Upstream's make install would install the plugin in /usr/plugin, so we do not
# rely on it and install manually
override_dh_auto_install:
	$(INSTALL_DIR) $(DESTDIR)$(PLUGIN_DIR_SERIAL)
	$(INSTALL_PROGRAM) src/plugin/libh5zzfp.so $(DESTDIR)$(PLUGIN_DIR_SERIAL)

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
https://api.github.com/repos/LLNL/H5Z-ZFP/releases?per_page=100 \
https://api.github.com/repos/LLNL/H5Z-ZFP/tarball/@ANY_VERSION@
